// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/CheckNumberedItems.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class CheckNumberedItems extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int inNumberedList = 2;
  public static final int inCheckNumber = 4;
  public static final int inVirgolette = 6;
  public static final int inSkip = 8;
  public static final int inPre = 10;
  public static final int inTable = 12;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6, 6
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\2\0\1\5\4\0\1\6"+
    "\1\7\1\10\1\11\10\10\1\12\1\13\1\14\1\0"+
    "\1\15\2\0\1\16\1\17\2\0\1\20\1\0\1\21"+
    "\1\22\1\23\1\0\1\24\1\25\1\26\1\27\1\30"+
    "\1\31\1\0\1\32\1\33\1\34\1\0\1\35\12\0"+
    "\1\16\1\17\2\0\1\20\1\0\1\21\1\22\1\23"+
    "\1\0\1\24\1\25\1\26\1\27\1\30\1\31\1\0"+
    "\1\32\1\33\1\34\1\0\1\35\64\0\1\3\204\0"+
    "\2\23\115\0\1\33\u0182\0\1\1\31\0\1\3\u010d\0"+
    "\1\24\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\11\0\6\1\2\2\4\1\16\0\1\3\47\0\1\4"+
    "\36\0\1\5\26\0\1\6\62\0\1\7\24\0\1\4"+
    "\1\0\1\10\4\0\1\11\4\0\1\12\27\0\1\13"+
    "\15\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[251];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\36\0\74\0\132\0\170\0\226\0\264\0\322"+
    "\0\360\0\u010e\0\u012c\0\u014a\0\u0168\0\u0186\0\u01a4\0\u010e"+
    "\0\u01c2\0\u01e0\0\u01fe\0\u021c\0\u023a\0\u0258\0\u0276\0\u0294"+
    "\0\u012c\0\u02b2\0\u02d0\0\u014a\0\u0168\0\u01a4\0\u02ee\0\u0186"+
    "\0\u030c\0\u032a\0\u0348\0\u010e\0\u01c2\0\u0366\0\u0384\0\u03a2"+
    "\0\u03c0\0\u03de\0\u03fc\0\u0294\0\u041a\0\u0438\0\u0456\0\u0474"+
    "\0\u0492\0\u04b0\0\u04ce\0\u04ec\0\u050a\0\u0528\0\u0546\0\u0564"+
    "\0\u0582\0\u05a0\0\u05be\0\u05dc\0\u05fa\0\u0618\0\u0636\0\u0654"+
    "\0\u0672\0\u0690\0\u06ae\0\u06cc\0\u06ea\0\u0708\0\u0726\0\u0744"+
    "\0\u0762\0\u0780\0\u079e\0\u07bc\0\u07da\0\u07f8\0\u0816\0\u0834"+
    "\0\u0852\0\u0870\0\u088e\0\u08ac\0\u08ca\0\u08e8\0\u0906\0\u0924"+
    "\0\u0942\0\u07bc\0\u0960\0\u097e\0\u099c\0\u09ba\0\u09d8\0\u09f6"+
    "\0\u0a14\0\u0a32\0\u0a50\0\u0a6e\0\u0a8c\0\u0aaa\0\u0ac8\0\u0ae6"+
    "\0\u0b04\0\u0b22\0\u010e\0\u0b40\0\u0b5e\0\u0b7c\0\u0b9a\0\u0bb8"+
    "\0\u0bd6\0\u0bf4\0\u0c12\0\u0c30\0\u0c4e\0\u0c6c\0\u0c8a\0\u0ca8"+
    "\0\u0cc6\0\u0ce4\0\u0d02\0\u0d20\0\u0d3e\0\u0d5c\0\u0d7a\0\u0d98"+
    "\0\u0db6\0\u010e\0\u0dd4\0\u0df2\0\u0e10\0\u0e2e\0\u0e4c\0\u0e6a"+
    "\0\u0e88\0\u0ea6\0\u0ec4\0\u0ee2\0\u0f00\0\u0f1e\0\u0f3c\0\u0f5a"+
    "\0\u0f78\0\u0f96\0\u0fb4\0\u0fd2\0\u0ff0\0\u100e\0\u102c\0\u104a"+
    "\0\u1068\0\u1086\0\u10a4\0\u10c2\0\u10e0\0\u10fe\0\u111c\0\u113a"+
    "\0\u1158\0\u1176\0\u1194\0\u11b2\0\u11d0\0\u11ee\0\u120c\0\u122a"+
    "\0\u1248\0\u1266\0\u1284\0\u12a2\0\u12c0\0\u12de\0\u12fc\0\u131a"+
    "\0\u1338\0\u1356\0\u1374\0\u1392\0\u010e\0\u13b0\0\u13ce\0\u13ec"+
    "\0\u140a\0\u1428\0\u1446\0\u1464\0\u1482\0\u14a0\0\u14be\0\u14dc"+
    "\0\u14fa\0\u1518\0\u1536\0\u1554\0\u1572\0\u1590\0\u15ae\0\u15cc"+
    "\0\u15ea\0\u010e\0\u1608\0\u010e\0\u1626\0\u1644\0\u1662\0\u1680"+
    "\0\u010e\0\u169e\0\u16bc\0\u16da\0\u16f8\0\u010e\0\u1716\0\u1734"+
    "\0\u1752\0\u1770\0\u178e\0\u17ac\0\u17ca\0\u17e8\0\u1806\0\u1824"+
    "\0\u1842\0\u1860\0\u187e\0\u189c\0\u18ba\0\u18d8\0\u18f6\0\u1914"+
    "\0\u1932\0\u1950\0\u196e\0\u198c\0\u19aa\0\u010e\0\u19c8\0\u19e6"+
    "\0\u1a04\0\u1a22\0\u1a40\0\u1a5e\0\u1a7c\0\u1a9a\0\u1ab8\0\u1ad6"+
    "\0\u1af4\0\u1b12\0\u1b30";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[251];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\12\12\1\13\24\12\2\14\1\12\1\15\1\12\1\16"+
    "\5\12\1\17\21\12\10\20\2\21\24\20\14\12\1\22"+
    "\35\12\1\23\35\12\1\24\35\12\1\25\21\12\1\0"+
    "\2\10\1\0\1\26\7\0\1\27\27\0\1\30\66\0"+
    "\2\31\1\0\1\32\7\0\1\33\22\0\2\34\1\0"+
    "\1\35\7\0\1\36\50\0\1\37\7\0\2\40\1\0"+
    "\1\41\7\0\1\42\43\0\1\43\21\0\1\44\1\0"+
    "\2\45\33\0\1\46\35\0\1\47\35\0\1\50\35\0"+
    "\1\51\55\0\1\52\30\0\1\53\23\0\2\54\53\0"+
    "\1\55\15\0\1\56\45\0\1\57\45\0\1\60\15\0"+
    "\1\61\40\0\1\62\51\0\1\63\35\0\1\64\31\0"+
    "\1\65\35\0\1\66\32\0\1\67\30\0\1\70\42\0"+
    "\1\71\40\0\1\72\46\0\1\73\21\0\1\74\40\0"+
    "\1\75\44\0\1\76\36\0\1\77\35\0\1\100\15\0"+
    "\1\101\35\0\1\102\56\0\1\103\33\0\1\104\37\0"+
    "\1\105\14\0\1\106\54\0\1\107\37\0\1\110\14\0"+
    "\1\111\24\0\1\112\2\0\1\113\10\0\1\114\44\0"+
    "\1\115\35\0\1\116\42\0\1\117\40\0\1\120\32\0"+
    "\1\121\5\0\1\122\2\0\1\123\10\0\1\124\51\0"+
    "\1\125\35\0\1\126\17\0\1\34\53\0\1\127\35\0"+
    "\1\130\4\0\15\112\1\114\20\112\27\0\1\131\7\0"+
    "\2\132\1\133\1\134\3\0\2\135\2\0\1\136\33\0"+
    "\1\137\35\0\1\140\55\0\1\141\21\0\1\142\32\0"+
    "\1\10\22\0\15\122\1\124\20\122\27\0\1\143\7\0"+
    "\2\124\1\0\1\144\44\0\1\31\37\0\1\145\33\0"+
    "\1\40\37\0\1\146\37\0\1\147\17\0\2\133\1\0"+
    "\1\150\7\0\1\151\50\0\1\152\14\0\1\153\1\0"+
    "\2\135\33\0\1\154\4\0\1\133\5\0\1\155\3\0"+
    "\1\156\44\0\1\157\33\0\1\160\22\0\1\161\34\0"+
    "\1\162\35\0\1\163\45\0\1\164\7\0\2\145\1\0"+
    "\1\165\7\0\1\166\22\0\2\146\1\0\1\167\7\0"+
    "\1\170\54\0\1\171\31\0\1\172\34\0\1\173\26\0"+
    "\1\174\40\0\1\175\25\0\1\176\55\0\1\177\26\0"+
    "\1\200\36\0\1\201\26\0\1\202\45\0\1\141\43\0"+
    "\1\203\21\0\1\204\45\0\1\205\30\0\1\206\42\0"+
    "\1\207\30\0\1\210\44\0\1\211\23\0\1\212\50\0"+
    "\1\213\36\0\1\214\14\0\1\215\54\0\1\216\2\0"+
    "\1\217\25\0\1\220\43\0\1\221\26\0\1\222\43\0"+
    "\1\223\37\0\1\224\21\0\1\225\30\0\1\226\42\0"+
    "\1\227\30\0\1\230\36\0\1\112\55\0\1\231\26\0"+
    "\1\232\42\0\1\233\35\0\1\234\36\0\1\235\21\0"+
    "\1\236\31\0\1\237\44\0\1\240\45\0\1\161\17\0"+
    "\1\122\53\0\1\241\37\0\1\242\33\0\1\243\37\0"+
    "\1\244\33\0\1\245\35\0\1\246\16\0\1\247\36\0"+
    "\1\132\37\0\1\12\40\0\1\250\34\0\1\251\51\0"+
    "\1\252\32\0\1\253\20\0\1\124\53\0\1\254\5\0"+
    "\1\255\2\0\1\256\10\0\1\257\51\0\1\260\5\0"+
    "\1\261\2\0\1\262\10\0\1\263\33\0\1\133\57\0"+
    "\1\264\15\250\1\265\20\250\25\0\1\266\34\0\1\267"+
    "\36\0\1\270\23\0\1\145\22\0\15\255\1\257\20\255"+
    "\27\0\1\271\7\0\2\257\1\0\1\272\4\0\1\273"+
    "\2\0\1\274\34\0\1\146\22\0\15\261\1\263\20\261"+
    "\27\0\1\275\7\0\2\263\1\0\1\276\3\0\2\277"+
    "\47\0\1\300\32\0\1\301\40\0\1\302\32\0\1\303"+
    "\34\0\1\304\45\0\1\305\14\0\1\306\36\0\1\307"+
    "\45\0\1\310\45\0\1\311\14\0\1\312\1\0\2\277"+
    "\56\0\1\313\3\0\15\301\1\314\20\301\31\0\1\315"+
    "\40\0\1\316\34\0\1\317\21\0\1\320\16\0\5\321"+
    "\1\0\2\321\2\0\24\321\22\0\1\322\46\0\1\323"+
    "\21\0\1\324\37\0\1\325\31\0\1\326\54\0\1\141"+
    "\32\0\1\327\37\0\1\330\14\0\1\331\54\0\1\332"+
    "\37\0\1\333\32\0\1\334\20\0\1\255\53\0\1\335"+
    "\35\0\1\336\17\0\1\261\53\0\1\337\31\0\1\340"+
    "\23\0\1\257\37\0\1\341\33\0\1\263\42\0\1\342"+
    "\16\0\2\341\1\0\1\343\7\0\1\344\55\0\1\345"+
    "\30\0\1\346\30\0\1\347\47\0\1\350\20\0\1\351"+
    "\30\0\1\352\43\0\1\353\50\0\1\354\33\0\1\355"+
    "\21\0\1\356\51\0\1\357\5\0\1\360\2\0\1\361"+
    "\10\0\1\362\33\0\1\341\22\0\15\360\1\362\20\360"+
    "\27\0\1\363\7\0\2\362\1\0\1\364\4\0\1\273"+
    "\43\0\1\365\45\0\1\366\41\0\1\367\21\0\1\370"+
    "\47\0\1\371\37\0\1\372\15\0\1\360\53\0\1\373"+
    "\17\0\1\362\22\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[6990];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\11\0\1\11\5\1\1\11\5\1\16\0\1\11\7\0"+
    "\1\1\37\0\1\1\7\0\1\1\26\0\1\11\26\0"+
    "\1\11\62\0\1\11\24\0\1\11\1\0\1\11\4\0"+
    "\1\11\4\0\1\11\27\0\1\11\15\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[251];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** For the backwards DFA of general lookahead statements */
  private boolean [] zzFin = new boolean [Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())+1];

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	CheckNumberedItems() { }

	private int numberSequence = 0;
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public CheckNumberedItems(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { output.append(yytext());
            }
          // fall through
          case 12: break;
          case 2:
            { output.append(yytext()); yybegin(0);
            }
          // fall through
          case 13: break;
          case 3:
            { int value = Integer.valueOf(yytext().substring(0,yylength()-1));
		
		numberSequence++;
		
		if(numberSequence != value) {
			
			output.append(yytext());

			yybegin(0);
		
		} else {
	
			output.append(String.valueOf(value) + ")");
			
			yybegin(inNumberedList);		
		}
            }
          // fall through
          case 14: break;
          case 4:
            { output.append(yytext());
		yybegin(0);
            }
          // fall through
          case 15: break;
          case 5:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 7;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 8;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { output.append(yytext());
		yybegin(inCheckNumber);
            }
          // fall through
          case 16: break;
          case 6:
            { output.append(yytext()); yybegin(inNumberedList);
            }
          // fall through
          case 17: break;
          case 7:
            { output.append(yytext()); yybegin(inPre);
            }
          // fall through
          case 18: break;
          case 8:
            { output.append(yytext()); yybegin(inTable);
            }
          // fall through
          case 19: break;
          case 9:
            { output.append(yytext().substring(0, yylength()-3) + "1)");
	yypushback(1);
	
	if(numberSequence == 0) {
		
		//getMarkerDocument().addWarning("idref:" + getMarkerDocument().getContext().getContainerId() + " Effettuata sostituzione delle intestazioni di liste numeriche ambigue \"1. 2. 3.\" -> \"1) 2) 3)\"");
		
		getMarkerDocument().addWarning("Effettuata sostituzione delle intestazioni di liste numeriche ambigue \"1. 2. 3.\" -> \"1) 2) 3)\"");
	}
	
	numberSequence = 1;
	
	yybegin(inNumberedList);
            }
          // fall through
          case 20: break;
          case 10:
            { output.append(yytext()); yybegin(inSkip);
            }
          // fall through
          case 21: break;
          case 11:
            { output.append(yytext()); yybegin(inVirgolette);
            }
          // fall through
          case 22: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java CheckNumberedItems [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        CheckNumberedItems scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new CheckNumberedItems(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
